----------------------------
----------------------------
---- Playing Cards Code ----
---------Player.lua---------
----------------------------

Player = {};

--Player.Create()
--@param:	Name
--@desc: 	Creates a new instace of this object.
--@return: 	the new instance.
function Player.Create(Name)
	local player_obj = {};
	--assign any default vars
	player_obj.name 	= Name;
	player_obj.hand		= {};

	--assign functions (yeah this bit sucks compared to other languages... but lua really isn't OO... le sigh)
	player_obj.ShowCards= Player.ShowCards;
	player_obj.AddToHand= Player.AddToHand;
	
	return player_obj;
end

--Player.ShowCards()
--@param:	self
--@desc:	Prints out the Player's Hand
--@desc:	A For Loop to call Card.Print, which prints
--@desc:	Cards out one by one. It does this for every
--@desc:	Card Object in Player.hand.
--@return:	nil
function Player.ShowCards(self)
	print(self.name.."'s Hand { ");
	
	for i = 1, #self.hand do
		Card.Print(self.hand[i]);
	end
	
	print("}");
end

--Player.AddToHand()
--@param:	self
--@param:	card_obj
--@desc:	Takes in a self argument (Player Object)
--@desc:	and a card_obj (Card Object) argument to 
--@desc:	add the last entry in the Deck.cards table
--@desc:	to the Player.hand table.
--@return:	nil
function Player.AddToHand(self, card_obj)
	
	table.insert(self.hand, card_obj);	
end